---
title: CLI
description: OpenCode CLI-alternativer og kommandoer.
---

import { Tabs, TabItem } from "@astrojs/starlight/components"

OpenCode CLI starter som standard [TUI](/docs/tui) når den kjøres uten noen argumenter.

```bash
opencode
```

Men den godtar også kommandoer som dokumentert på denne siden. Dette lar deg samhandle med OpenCode programmatisk.

```bash
opencode run "Explain how closures work in JavaScript"
```

---

### tui

Start OpenCode-terminalbrukergrensesnittet.

```bash
opencode [project]
```

#### Flagg

| Flagg        | Kort | Beskrivelse                                                              |
| ------------ | ---- | ------------------------------------------------------------------------ |
| `--continue` | `-c` | Fortsett siste økt                                                       |
| `--session`  | `-s` | Økt ID for å fortsette                                                   |
| `--fork`     |      | Forgren økten ved fortsettelse (bruk med `--continue` eller `--session`) |
| `--prompt`   |      | Ledetekst som skal brukes                                                |
| `--model`    | `-m` | Modell å bruke i form av leverandør/modell                               |
| `--agent`    |      | Agent som skal brukes                                                    |
| `--port`     |      | Port å lytte på                                                          |
| `--hostname` |      | Vertsnavn å lytte på                                                     |

---

## Kommandoer

OpenCode CLI har også følgende kommandoer.

---

### agent

Administrer agenter for OpenCode.

```bash
opencode agent [command]
```

---

### attach

Koble en terminal til en allerede kjørende OpenCode-backend-server startet via `serve` eller `web` kommandoer.

```bash
opencode attach [url]
```

Dette gjør det mulig å bruke TUI med en ekstern OpenCode-backend. For eksempel:

```bash
# Start the backend server for web/mobile access
opencode web --port 4096 --hostname 0.0.0.0

# In another terminal, attach the TUI to the running backend
opencode attach http://10.20.30.40:4096
```

#### Flagg

| Flagg       | Kort | Beskrivelse                       |
| ----------- | ---- | --------------------------------- |
| `--dir`     |      | Arbeidskatalog for å starte TUI i |
| `--session` | `-s` | Økt ID for å fortsette            |

---

#### create

Opprett en ny agent med tilpasset konfigurasjon.

```bash
opencode agent create
```

Denne kommandoen vil veilede deg gjennom å lage en ny agent med en tilpasset systemmelding og verktøykonfigurasjon.

---

#### list

List opp alle tilgjengelige agenter.

```bash
opencode agent list
```

---

### auth

Kommando for administrasjon av påloggingsinformasjon og innlogging for leverandører.

```bash
opencode auth [command]
```

---

#### login

OpenCode drives av leverandørlisten på [Models.dev](https://models.dev), så du kan bruke `opencode auth login` til å konfigurere API-nøkler for enhver leverandør du vil bruke. Dette er lagret i `~/.local/share/opencode/auth.json`.

```bash
opencode auth login
```

Når OpenCode starter opp, laster den leverandørene fra filen med påloggingsinformasjon. Og hvis det er noen nøkler definert i miljøene dine eller en `.env`-fil i prosjektet ditt.

---

#### list

Viser alle de autentiserte leverandørene som er lagret i filen med påloggingsinformasjon.

```bash
opencode auth list
```

Eller bruk kortversjonen.

```bash
opencode auth ls
```

---

#### logout

Logger deg ut av en leverandør ved å fjerne den fra filen med påloggingsinformasjon.

```bash
opencode auth logout
```

---

### github

Administrer GitHub-agenten for depotautomatisering.

```bash
opencode github [command]
```

---

#### install

Installer GitHub-agenten i depotet ditt.

```bash
opencode github install
```

Dette setter opp den nødvendige GitHub Actions-arbeidsflyten og veileder deg gjennom konfigurasjonsprosessen. [Finn ut mer](/docs/github).

---

#### run

Kjør GitHub-agenten. Dette brukes vanligvis i GitHub Actions.

```bash
opencode github run
```

##### Flagg

| Flagg     | Beskrivelse                                  |
| --------- | -------------------------------------------- |
| `--event` | GitHub mock-hendelse agenten skal kjøres for |
| `--token` | GitHub personlig tilgangsnøkkel              |

---

### mcp

Administrer Model Context Protocol-servere.

```bash
opencode mcp [command]
```

---

#### add

Legg til en MCP-server til konfigurasjonen.

```bash
opencode mcp add
```

Denne kommandoen vil veilede deg gjennom å legge til enten en lokal eller ekstern MCP-server.

---

#### list

Liste alle konfigurerte MCP-servere og deres tilkoblingsstatus.

```bash
opencode mcp list
```

Eller bruk den korte versjonen.

```bash
opencode mcp ls
```

---

#### auth

Autentiser med en OAuth-aktivert MCP-server.

```bash
opencode mcp auth [name]
```

Hvis du ikke oppgir et servernavn, blir du bedt om å velge blant tilgjengelige OAuth-kompatible servere.

Du kan også liste opp OAuth-kompatible servere og deres autentiseringsstatus.

```bash
opencode mcp auth list
```

Eller bruk den korte versjonen.

```bash
opencode mcp auth ls
```

---

#### logout

Fjern OAuth-påloggingsinformasjon for en MCP-server.

```bash
opencode mcp logout [name]
```

---

#### debug

Feilsøk OAuth-tilkoblingsproblemer for en MCP-server.

```bash
opencode mcp debug <name>
```

---

### models

List opp alle tilgjengelige modeller fra konfigurerte leverandører.

```bash
opencode models [provider]
```

Denne kommandoen viser alle modeller som er tilgjengelige på tvers av dine konfigurerte leverandører i formatet `provider/model`.

Dette er nyttig for å finne ut det eksakte modellnavnet som skal brukes i [din konfigurasjon](/docs/config/).

Du kan eventuelt sende en leverandør ID for å filtrere modeller etter den leverandøren.

```bash
opencode models anthropic
```

#### Flagg

| Flagg       | Beskrivelse                                                         |
| ----------- | ------------------------------------------------------------------- |
| `--refresh` | Oppdater modellbufferen fra models.dev                              |
| `--verbose` | Bruk mer detaljert modellutdata (inkluderer metadata som kostnader) |

Bruk `--refresh`-flagget for å oppdatere den bufrede modelllisten. Dette er nyttig når nye modeller er lagt til en leverandør og du vil se dem i OpenCode.

```bash
opencode models --refresh
```

---

### run

Kjør OpenCode i ikke-interaktiv modus ved å sende en melding direkte.

```bash
opencode run [message..]
```

Dette er nyttig for skripting, automatisering eller når du vil ha et raskt svar uten å starte hele TUI. For eksempel.

```bash "opencode run"
opencode run Explain the use of context in Go
```

Du kan også koble til en kjørende `opencode serve`-forekomst for å unngå MCP-serveres kaldstarttid ved hver kjøring:

```bash
# Start a headless server in one terminal
opencode serve

# In another terminal, run commands that attach to it
opencode run --attach http://localhost:4096 "Explain async/await in JavaScript"
```

#### Flagg

| Flagg        | Kort | Beskrivelse                                                              |
| ------------ | ---- | ------------------------------------------------------------------------ |
| `--command`  |      | Kommandoen for å kjøre, bruk melding for args                            |
| `--continue` | `-c` | Fortsett siste økt                                                       |
| `--session`  | `-s` | Økt ID for å fortsette                                                   |
| `--fork`     |      | Forgren økten ved fortsettelse (bruk med `--continue` eller `--session`) |
| `--share`    |      | Del økten                                                                |
| `--model`    | `-m` | Modell å bruke i form av leverandør/modell                               |
| `--agent`    |      | Agent å bruke                                                            |
| `--file`     | `-f` | Fil(er) som skal legges ved meldingen                                    |
| `--format`   |      | Format: standard (formatert) eller json (rå JSON hendelser)              |
| `--title`    |      | Tittel for økten (bruker avkortet ledetekst hvis ingen verdi er oppgitt) |
| `--attach`   |      | Koble til en kjørende OpenCode-server (f.eks. http://localhost:4096)     |
| `--port`     |      | Port for den lokale serveren (standard til tilfeldig port)               |

---

### serve

Start en headless OpenCode-server for API-tilgang. Sjekk ut [server-dokumentene](/docs/server) for hele HTTP-grensesnittet.

```bash
opencode serve
```

Dette starter en HTTP-server som gir API tilgang til OpenCode-funksjonalitet uten TUI-grensesnittet. Sett `OPENCODE_SERVER_PASSWORD` for å aktivere HTTP grunnleggende autentisering (brukernavn er standard til `opencode`).

#### Flagg

| Flagg        | Beskrivelse                                        |
| ------------ | -------------------------------------------------- |
| `--port`     | Port å lytte på                                    |
| `--hostname` | Vertsnavn å lytte på                               |
| `--mdns`     | Aktiver mDNS-oppdagelse                            |
| `--cors`     | Ytterligere nettleseropprinnelse som tillater CORS |

---

### session

Administrer OpenCode-økter.

```bash
opencode session [command]
```

---

#### list

List opp alle OpenCode-økter.

```bash
opencode session list
```

##### Flagg

| Flagg         | Kort | Beskrivelse                              |
| ------------- | ---- | ---------------------------------------- |
| `--max-count` | `-n` | Begrens til N siste økter                |
| `--format`    |      | Utdataformat: tabell eller json (tabell) |

---

### stats

Vis tokenbruk og kostnadsstatistikk for OpenCode-øktene dine.

```bash
opencode stats
```

#### Flagg

| Flagg       | Beskrivelse                                                                      |
| ----------- | -------------------------------------------------------------------------------- |
| `--days`    | Vis statistikk for de siste N dagene (hele tiden)                                |
| `--tools`   | Antall verktøy som skal vises (alle)                                             |
| `--models`  | Vis oversikt over modellbruk (skjult som standard). Gi et tall for å vise topp N |
| `--project` | Filtrer etter prosjekt (alle prosjekter, tom streng: gjeldende prosjekt)         |

---

### export

Eksporter øktdata som JSON.

```bash
opencode export [sessionID]
```

Hvis du ikke gir en økt ID, blir du bedt om å velge fra tilgjengelige økter.

---

### import

Importer øktdata fra en JSON-fil eller en OpenCode share-URL.

```bash
opencode import <file>
```

Du kan importere fra en lokal fil eller en OpenCode share-URL.

```bash
opencode import session.json
opencode import https://opncd.ai/s/abc123
```

---

### web

Start en headless OpenCode-server med et webgrensesnitt.

```bash
opencode web
```

Dette starter en HTTP-server og åpner en nettleser for å få tilgang til OpenCode via et nettgrensesnitt. Sett `OPENCODE_SERVER_PASSWORD` for å aktivere HTTP grunnleggende autentisering (brukernavn er standard til `opencode`).

#### Flagg

| Flagg        | Beskrivelse                                        |
| ------------ | -------------------------------------------------- |
| `--port`     | Port å lytte på                                    |
| `--hostname` | Vertsnavn å lytte på                               |
| `--mdns`     | Aktiver mDNS-oppdagelse                            |
| `--cors`     | Ytterligere nettleseropprinnelse som tillater CORS |

---

### acp

Start en ACP (Agent Client Protocol) server.

```bash
opencode acp
```

Denne kommandoen starter en ACP-server som kommuniserer via stdin/stdout ved å bruke nd-JSON.

#### Flagg

| Flagg        | Beskrivelse          |
| ------------ | -------------------- |
| `--cwd`      | Arbeidskatalog       |
| `--port`     | Port å lytte på      |
| `--hostname` | Vertsnavn å lytte på |

---

### uninstall

Avinstaller OpenCode og fjern alle relaterte filer.

```bash
opencode uninstall
```

#### Flagg

| Flagg           | Kort | Beskrivelse                                   |
| --------------- | ---- | --------------------------------------------- |
| `--keep-config` | `-c` | Behold konfigurasjonsfiler                    |
| `--keep-data`   | `-d` | Behold øktdata og øyeblikksbilder             |
| `--dry-run`     |      | Vis hva som ville blitt fjernet uten å fjerne |
| `--force`       | `-f` | Hopp over bekreftelsesforespørsler            |

---

### upgrade

Oppdaterer OpenCode til siste versjon eller en spesifikk versjon.

```bash
opencode upgrade [target]
```

For å oppgradere til siste versjon.

```bash
opencode upgrade
```

For å oppgradere til en bestemt versjon.

```bash
opencode upgrade v0.1.48
```

#### Flagg

| Flagg      | Kort | Beskrivelse                                                    |
| ---------- | ---- | -------------------------------------------------------------- |
| `--method` | `-m` | Installasjonsmetoden som ble brukt: curl, npm, pnpm, bun, brew |

---

## Globale flagg

OpenCode CLI bruker følgende globale flagg.

| Flagg          | Kort | Beskrivelse                         |
| -------------- | ---- | ----------------------------------- |
| `--help`       | `-h` | Vis hjelp                           |
| `--version`    | `-v` | Skriv ut versjonsnummer             |
| `--print-logs` |      | Skriv ut logger til stderr          |
| `--log-level`  |      | Loggnivå (DEBUG, INFO, WARN, ERROR) |

---

## Miljøvariabler

OpenCode kan konfigureres ved hjelp av miljøvariabler.

| Variabel                              | Type   | Beskrivelse                                                           |
| ------------------------------------- | ------ | --------------------------------------------------------------------- |
| `OPENCODE_AUTO_SHARE`                 | boolsk | Del økter automatisk                                                  |
| `OPENCODE_GIT_BASH_PATH`              | streng | Bane til Git Bash-kjørbar på Windows                                  |
| `OPENCODE_CONFIG`                     | streng | Bane til konfigurasjonsfil                                            |
| `OPENCODE_TUI_CONFIG`                 | streng | Bane til TUI-konfigurasjonsfil                                        |
| `OPENCODE_CONFIG_DIR`                 | streng | Bane til konfigurasjonskatalog                                        |
| `OPENCODE_CONFIG_CONTENT`             | streng | Innebygd json-konfigurasjonsinnhold                                   |
| `OPENCODE_DISABLE_AUTOUPDATE`         | boolsk | Deaktiver automatiske oppdateringskontroller                          |
| `OPENCODE_DISABLE_PRUNE`              | boolsk | Deaktiver beskjæring av gamle data                                    |
| `OPENCODE_DISABLE_TERMINAL_TITLE`     | boolsk | Deaktiver automatiske terminaltitteloppdateringer                     |
| `OPENCODE_PERMISSION`                 | streng | Innebygd json-tillatelseskonfigurasjon                                |
| `OPENCODE_DISABLE_DEFAULT_PLUGINS`    | boolsk | Deaktiver standard plugins                                            |
| `OPENCODE_DISABLE_LSP_DOWNLOAD`       | boolsk | Deaktiver automatiske LSP servernedlastinger                          |
| `OPENCODE_ENABLE_EXPERIMENTAL_MODELS` | boolsk | Aktiver eksperimentelle modeller                                      |
| `OPENCODE_DISABLE_AUTOCOMPACT`        | boolsk | Deaktiver automatisk kontekstkomprimering                             |
| `OPENCODE_DISABLE_CLAUDE_CODE`        | boolsk | Deaktiver lesing fra `.claude` (spørsmål + ferdigheter)               |
| `OPENCODE_DISABLE_CLAUDE_CODE_PROMPT` | boolsk | Deaktiver lesing `~/.claude/CLAUDE.md`                                |
| `OPENCODE_DISABLE_CLAUDE_CODE_SKILLS` | boolsk | Deaktiver innlasting av `.claude/skills`                              |
| `OPENCODE_DISABLE_MODELS_FETCH`       | boolsk | Deaktiver henting av modeller fra eksterne kilder                     |
| `OPENCODE_FAKE_VCS`                   | streng | Falsk VCS-leverandør for testformål                                   |
| `OPENCODE_DISABLE_FILETIME_CHECK`     | boolsk | Deaktiver filtidskontroll for optimalisering                          |
| `OPENCODE_CLIENT`                     | streng | Klientidentifikator (standard til `cli`)                              |
| `OPENCODE_ENABLE_EXA`                 | boolsk | Aktiver Exa-nettsøkeverktøy                                           |
| `OPENCODE_SERVER_PASSWORD`            | streng | Aktiver grunnleggende autentisering for `serve`/`web`                 |
| `OPENCODE_SERVER_USERNAME`            | streng | Overstyr grunnleggende autentiseringsbrukernavn (standard `opencode`) |
| `OPENCODE_MODELS_URL`                 | streng | Egendefinert URL for henting av modellkonfigurasjon                   |

---

### Eksperimentelt

Disse miljøvariablene muliggjør eksperimentelle funksjoner som kan endres eller fjernes.

| Variabel                                        | Type   | Beskrivelse                                   |
| ----------------------------------------------- | ------ | --------------------------------------------- |
| `OPENCODE_EXPERIMENTAL`                         | boolsk | Aktiver alle eksperimentelle funksjoner       |
| `OPENCODE_EXPERIMENTAL_ICON_DISCOVERY`          | boolsk | Aktiver ikonoppdagelse                        |
| `OPENCODE_EXPERIMENTAL_DISABLE_COPY_ON_SELECT`  | boolsk | Deaktiver kopi ved valg i TUI                 |
| `OPENCODE_EXPERIMENTAL_BASH_DEFAULT_TIMEOUT_MS` | tall   | Standard tidsavbrudd for bash-kommandoer i ms |
| `OPENCODE_EXPERIMENTAL_OUTPUT_TOKEN_MAX`        | tall   | Maks Output Tokens for LLM-svar               |
| `OPENCODE_EXPERIMENTAL_FILEWATCHER`             | boolsk | Aktiver filovervåker for hele dir             |
| `OPENCODE_EXPERIMENTAL_OXFMT`                   | boolsk | Aktiver oxfmt formatter                       |
| `OPENCODE_EXPERIMENTAL_LSP_TOOL`                | boolsk | Aktiver eksperimentelt LSP-verktøy            |
| `OPENCODE_EXPERIMENTAL_DISABLE_FILEWATCHER`     | boolsk | Deaktiver filovervåking                       |
| `OPENCODE_EXPERIMENTAL_EXA`                     | boolsk | Aktiver eksperimentelle Exa-funksjoner        |
| `OPENCODE_EXPERIMENTAL_LSP_TY`                  | boolsk | Aktiver TY LSP for python-filer               |
| `OPENCODE_EXPERIMENTAL_MARKDOWN`                | boolsk | Aktiver eksperimentelle Markdown-funksjoner   |
| `OPENCODE_EXPERIMENTAL_PLAN_MODE`               | boolsk | Aktiver planmodus                             |
